
source("plot3dTools.R")

showSurface = T

xGrid=-40:40/10
yGrid=xGrid

a=0

f<-function(x,y){

  z=-x^2+a*x*y-y^2

  return(z)

}

fGrid = matrix(0,nrow=length(xGrid),ncol=length(yGrid))

for(i in 1:length(xGrid)){
  for(j in 1:length(yGrid)){
    fGrid[i,j]=f(xGrid[i],yGrid[j])

  }
}

density=makeMesh(xGrid,yGrid,fGrid)
zeroPlane=makeMesh(xGrid,yGrid,matrix(0,nrow=length(xGrid),ncol=length(yGrid)))


wins=numeric()

window=open3d()
wins=append(wins,window)

if(showSurface){
  shade3d(density,color="blue",alpha=1)
  shade3d(zeroPlane,color="grey",alpha=0.8)
}

for(i in 1:length(yGrid)){
  if(yGrid[i]*2==floor(yGrid[i]*2)){
    lines3d(xGrid,yGrid[i],fGrid[,i])
  }
}
for(i in 1:length(xGrid)){
  if(xGrid[i]*2==floor(xGrid[i]*2)){
    lines3d(xGrid[i],yGrid,fGrid[i,])
  }
}


aspect3d(1,1,0.8)
axes3d()
title3d(main="",ylab="Y",xlab="X")


rgl.light( theta = 50, phi = 0, viewpoint.rel = TRUE, ambient = "#FFFFFF", 
           diffuse = "#FFFFFF", specular = "#FFFFFF", x = NULL, y = NULL, z = NULL)
