library(rgl)

makeMesh<-function(x,y,z){

    vertices=matrix(0,nrow=4,ncol=0)

    for(i in 1:length(x)){

        for(j in 1:length(y))

        vertices=cbind(vertices,matrix(c(x[i],y[j],z[i,j],1),nrow=4))

    }

    indices=matrix(0,nrow=4,ncol=0)

    for(i in 1:(length(x)-1)){

        for(j in 1:(length(y)-1)){

            indices=cbind(indices,
                    matrix(c((i-1)*length(y)+j,(i-1)*length(y)+j+1,(i)*length(y)+j+1,(i)*length(y)+j),nrow=4))
        }
        
    }

    return(qmesh3d(vertices,indices))

}

closeWindows <- function(){
  if(exists("wins")){

    winstemp=wins
    wins=numeric()

    for(w in winstemp){


        rgl.set(w)
        rgl.close()

    }

  }

}

